// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from graph_msgs:msg/GeometryGraph.idl
// generated code does not contain a copyright notice

#ifndef GRAPH_MSGS__MSG__DETAIL__GEOMETRY_GRAPH__TRAITS_HPP_
#define GRAPH_MSGS__MSG__DETAIL__GEOMETRY_GRAPH__TRAITS_HPP_

#include "graph_msgs/msg/detail/geometry_graph__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'nodes'
#include "geometry_msgs/msg/detail/point__traits.hpp"
// Member 'edges'
#include "graph_msgs/msg/detail/edges__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const graph_msgs::msg::GeometryGraph & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: nodes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.nodes.size() == 0) {
      out << "nodes: []\n";
    } else {
      out << "nodes:\n";
      for (auto item : msg.nodes) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: edges
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.edges.size() == 0) {
      out << "edges: []\n";
    } else {
      out << "edges:\n";
      for (auto item : msg.edges) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const graph_msgs::msg::GeometryGraph & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<graph_msgs::msg::GeometryGraph>()
{
  return "graph_msgs::msg::GeometryGraph";
}

template<>
inline const char * name<graph_msgs::msg::GeometryGraph>()
{
  return "graph_msgs/msg/GeometryGraph";
}

template<>
struct has_fixed_size<graph_msgs::msg::GeometryGraph>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<graph_msgs::msg::GeometryGraph>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<graph_msgs::msg::GeometryGraph>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // GRAPH_MSGS__MSG__DETAIL__GEOMETRY_GRAPH__TRAITS_HPP_
